//+------------------------------------------------------------------+
//|                                               delete_pending.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
#property show_inputs
#property show_confirm

#include <WinUser32.mqh>
#include <stdlib.mqh>

extern int MagicNumber=0; // 0 means "all orders on current chart"

//+------------------------------------------------------------------+
//| script "delete first pending order"                              |
//+------------------------------------------------------------------+
int start()
{
//----

  Alert("--- START "+WindowExpertName()+" "+Symbol()+" "+OrdersTotal()+" orders");

  delete_pending_orders (Symbol(), MagicNumber);

  Alert("--- END "+WindowExpertName()+" "+Symbol());

  return(0);
}

//+------------------------------------------------------------------+
void delete_pending_orders (string symbol, double magic)
//+------------------------------------------------------------------+
{
  bool   result;
  int    cmd,err;
//----
  for (int i=0; i<OrdersTotal(); i++)
  {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
    {
      if (OrderSymbol()!=Symbol()) continue; // delete orders on current chart only
      if (magic != 0 && magic != OrderMagicNumber()) continue; // magic number does not match

      cmd=OrderType();
      //---- pending orders only are considered
      if(cmd!=OP_BUY && cmd!=OP_SELL)
      {
        //---- print selected order
        OrderPrint();
        Alert("Deleting Pending Order #"+OrderTicket());
        //---- delete first pending order
        result=OrderDelete(OrderTicket());
        i=-1;// when an order is deleted, indexes are re-computed, so scan again ALL orders
        if(result!=TRUE) {
          err = GetLastError();
          Alert("Error when OrderDelete()",err," : ",ErrorDescription(err));
        }
      }
    } else {
      err = GetLastError();
      Alert("Error when order select ",err," : ",ErrorDescription(err));
    }
  }
}

//+------------------------------------------------------------------+